#include "keys.h"
#define MAXLEN 15

int pr[MAXLEN];
int lastcg=0;
unsigned long it;

void q(void (*QFunc)(char*), char* err, char* txt)
{
 puts(err);
 puts("\n");
 (*QFunc)(txt);
 exit(20);
}

void ShowHelp(char* progname)
{
 puts("This program converts series of numbers into words such, as the numbers\n"\
      "were typed on the cellurar phone's keyboard. Good solution for people with\n"\
      "poor memory.\n"\
      "");
 printf("\nUsage: %s number\n", progname);
}

void Dummy(char* z)
{
}

void FullHelp(char* z)
{
 puts("This program is a good idea for people who need to remember a number\n"\
      "for example a phone number. It converts the number into letters, using\n"\
      "the way cellurar phones do it. Prints series of combinations on the screen.\n"\
      "However, the number of combinations is rather huge (4^# of digits), so it\n"\
      "might be a good idea to redirect program's output to ispell or any other\n"\
      "dictonarty. For example, for a typical 7-digits phone number, 16384 words\n"\
      "are generated.\n");
 printf("\nUsage: %s number\n", z);
 puts("\nVisit GDR!'s homepage at http://www.GDR.w.pl/\n\n");
}


void LenExceed(char* z)
{
 printf("The maximal lenght is %d\n", MAXLEN);
}


void IncrPos(int len)
{
 int pos;
 it++; 

 for(pos=0;pos<len;pos++)
 {
  pr[pos]=(it%(4<<(pos<<1)))>>(pos<<1);
 } /* FOR */
}

int main(int argc, char* argv[])
{
 unsigned long number;
 int pos;
 long loop;
 int a1len;

 puts("RememberPhone by GDR! / LucidDreams   [http://www.GDR.w.pl/]\n");
 if(argc<2) q(ShowHelp, "Too few arguments", argv[0]);
 if(argc>2) q(ShowHelp, "Too many arguments", argv[0]);
 if((!strcmp(argv[1],"-h"))||(!strcmp(argv[1],"--help"))||(!strcmp(argv[1],"?"))||(!strcmp(argv[1],"/?"))) q(FullHelp, "Help:", argv[0]);
 a1len=strlen(argv[1]);
 number=atol(argv[1]);
 if(number == 0) q(ShowHelp, "Argument is not a number (or is equal to 0)", argv[0]);
 if(a1len>MAXLEN) q(LenExceed, "Maximal number lenght exceeded. To change, recompile the program (keys.h)", 0);
 printf("Converting number %s into texts...\n", argv[1]);
 lastcg=a1len;
 loop=1<<(lastcg<<1);
 lastcg--;
 printf("%d iterations.\n",loop);
while(loop--)
{
 for(pos=0;pos<a1len;pos++)
 {
  printf("%c",key[((argv[1][pos])-48)][pr[pos]]);
 }
 printf("\n");
 IncrPos(a1len);
}
 return(0);
}